"use strict";

var initialCall = true;
var currentTimestamp, previousTimestamp;

if(localStorage.getItem("dryft_dateInstalled")){
    localStorage.removeItem("dryft_dateInstalled");
}

function initDryft(){
	var currentURL = document.URL;
	var monitorTitle;
	chrome.storage.local.get('websites', function(websitesObj){
		var websitesArr = websitesObj.websites;
		if(!websitesArr){
			return;
		}
		for(let el of websitesArr){
			for(let key in el){
				if(regexTest(currentURL, el[key])){
					monitorTitle = key;
					startCounter(monitorTitle);
					return;
				}
			}
		}
	});
		
	function regexTest(str, regexStr){
		var regex = new RegExp("\\b" + regexStr + "*");
		return regex.test(str);
	}
}

function startCounter(social_media_key){
    var currentTime = getCurrentTime(new Date());
    chrome.storage.local.get(null, function getStoredObj(resultObj){
        //-----Now don't need "dateInstalled" to do vaildations-----

        // var dateInstalled_new = resultObj.dateInstalled, dateInstalled_old = localStorage.getItem("dryft_dateInstalled");
		// if(dateInstalled_old){
		// 	if(dateInstalled_old == dateInstalled_new){
		// 		if(localStorage.getItem("writing") && localStorage.getItem("writing") != timestamp){
		// 			return;
		// 		}
		// 	}
		// 	else{
		// 		localStorage.setItem("dryft_dateInstalled", dateInstalled_new);
		// 	}
		// }
		// else{
		// 	localStorage.setItem("dryft_dateInstalled", dateInstalled_new);
        // }
        
        //following lines added in v1.1.0
        var storedTimestamp = +localStorage.getItem("dryft_timestamp");
        currentTimestamp = Date.now();

        if(!storedTimestamp){
            localStorage.setItem("dryft_timestamp", currentTimestamp);
            previousTimestamp = currentTimestamp;
            updateCounter();
        }
        else{
            if(previousTimestamp && (storedTimestamp == previousTimestamp)){
                localStorage.setItem("dryft_timestamp", currentTimestamp);
                previousTimestamp = currentTimestamp;
                updateCounter();
            }
            else if(storedTimestamp + 10000 < currentTimestamp){
                localStorage.setItem("dryft_timestamp", currentTimestamp);
                previousTimestamp = currentTimestamp;
                updateCounter();
            }

        }
        //till here


        function updateCounter(){
            var parentObj = resultObj || {};
            parentObj[social_media_key] = parentObj[social_media_key] || {};
            var socialMedia_Obj = parentObj[social_media_key];
            if(initialCall){
                initialCall = false;
                window.onbeforeunload = function() {
                    localStorage.removeItem("dryft_timestamp");
                };
            }
            socialMedia_Obj[currentTime[3]] = socialMedia_Obj[currentTime[3]] || {};
            var socialMedia_Year_Obj = socialMedia_Obj[currentTime[3]];
            socialMedia_Year_Obj[currentTime[2]] = socialMedia_Year_Obj[currentTime[2]] || {};
            var socialMedia_Year_Month_Obj = socialMedia_Year_Obj[currentTime[2]];
            socialMedia_Year_Month_Obj[currentTime[1]] = socialMedia_Year_Month_Obj[currentTime[1]] || new Array(24).fill(0, 0, 24);
            var socialMedia_Year_Month_Day_Obj = socialMedia_Year_Month_Obj[currentTime[1]];
            var initialValue = socialMedia_Year_Month_Day_Obj[currentTime[0]] || 0;
            initialValue = initialValue + 5;
            socialMedia_Year_Month_Day_Obj[currentTime[0]] = initialValue;
            chrome.storage.local.set(parentObj);
        }
    });
}

function printData(){
    chrome.storage.local.get(null, function(result){
        console.log(result);
        document.body.innerHTML = JSON.stringify(result, null, 4);
    })
}

function getCurrentTime(dateObj){
    var hour = dateObj.getHours();
    var date = dateObj.getDate();
    var month = getMonthInWords(dateObj.getMonth());
    var year = dateObj.getFullYear();
    return [hour, date, month, year];
}

function getMonthInWords(monthNumber){
    switch(monthNumber){
        case 0:
            return "JAN";
        case 1:
            return "FEB";
        case 2:
            return "MAR";
        case 3:
            return "APR";
        case 4:
            return "MAY";
        case 5:
            return "JUN";
        case 6:
            return "JUL";
        case 7:
            return "AUG";
        case 8:
            return "SEP";
        case 9:
            return "OCT";
        case 10:
            return "NOV";
        case 11:
            return "DEC";
    }
}

setInterval(function(){
	initDryft();
}, 5000);
