//---------------------Feedback popup related stuffs here----------------------

var helperDOMElements = {
        feedbackPopupContainer: document.querySelector(".feedback-popup-container")
};

function initFeedbackPopup(){
    var alreadyRated = localStorage.getItem("alreadyRated");
    if(alreadyRated){
        return;
    }

    var snoozedTill = localStorage.getItem("snoozedTill"); //number of ms for which feedback popup is snoozed
    if(!snoozedTill){
        //if first usage of the extension, set "snoozedTill" to three days later
        let currentMs = Date.now();
        let threeDaysLater = currentMs + 3*24*60*60*1000;
        localStorage.setItem("snoozedTill", threeDaysLater);
    }
    else if(snoozedTill < Date.now()){
        setTimeout(function(){
            fadeInFeedbackPopup(helperDOMElements.feedbackPopupContainer, 300);
        }, 500);
    }

    var yesButton, noButton;
    yesButton = document.querySelector(".first-button button");
    noButton = document.querySelector(".second-button button");

    yesButton.addEventListener("click", feedbackYesClicked);
    noButton.addEventListener("click", feedbackNoClicked);

    function feedbackYesClicked(){
        localStorage.setItem("alreadyRated", true);
        localStorage.removeItem("snoozedTill");
        window.open("https://chrome.google.com/webstore/detail/dryft/bpfibgbdeacmameoklggiabcekheipei/reviews", "_blank");
        setTimeout(function(){
            fadeOutFeedbackPopup(helperDOMElements.feedbackPopupContainer, 300);
            alert("Thanks for rating! :)");
        }, 1000);
    }

    function feedbackNoClicked(){
        //snooze for 4 days
        var currentMs = Date.now();
        var fourDaysLater = currentMs + 4*24*60*60*1000;
        localStorage.setItem("snoozedTill", fourDaysLater);
        
        setTimeout(function(){
            fadeOutFeedbackPopup(helperDOMElements.feedbackPopupContainer, 300);
        }, 300);
    }

}

function fadeInFeedbackPopup(el, ms){
    el.style.opacity = 0;
    el.style.display = "flex";
    var timeFactor = ms/100;
    for(let i = 1; i <= 100; i++){
        setTimeout(function(){
            el.style.opacity = i/100;
        }, timeFactor*i);
    }
}

function fadeOutFeedbackPopup(el, ms){
    var timeFactor = ms/100;
    for(let i = 100; i >= 1; i--){
        setTimeout(function(){
            el.style.opacity = i/100;
        }, timeFactor*(100 - i));
    }
    setTimeout(function(){
        el.style.display = "none";
    }, ms + 50);
}


function initHelpers(){
    // init "Feedback popup"
    initFeedbackPopup();

}


document.addEventListener("DOMContentLoaded", function(){
    initHelpers();
});